#!/usr/bin/perl

use strict;
use File::Copy;

my $httpd_conf = "/usr/local/apache/conf/httpd.conf";

# make backup copy first
File::Copy::copy($httpd_conf, $httpd_conf.".bak_cgi");

# add location cgi-bin
open(FH, '<', $httpd_conf.".bak_cgi");
open(FF, '>', $httpd_conf);

my $found_perlmod = 0;
my $found_location_cgi = 0;
while(my $line = <FH>)
{
	$line =~ s/ScriptAlias \/cgi-bin\/ "\/usr\/local\/apache\/cgi-bin"/ScriptAlias \/cgi-bin\/ "\/usr\/local\/apache\/cgi-bin\/"/g;
	if($line =~ /PerlModule Apache::Registry/)
	{
		$found_perlmod = 1;
	}
	
	if($line =~ /\<Location \/cgi-bin\>/)
	{
		$found_location_cgi = 1;
	}

	if(!$found_location_cgi || $found_perlmod)
	{
		print FF $line;
	}

	if($line =~ /<\/Location>/ && $found_location_cgi)
	{
		$found_location_cgi = 0;
	}
}

if(!$found_perlmod)
{
	print FF "\nPerlModule Apache::Registry\n";
	print FF "<Location /cgi-bin>\n";
	print FF "  AuthUserFile /etc/htpasswd\n";
	print FF "  AuthType Basic\n";
	print FF "  AuthName SecuredRPC\n";
	print FF "  require valid-user\n";
	print FF "  SetHandler perl-script\n";
	print FF "  PerlHandler Apache::Registry\n";
	print FF "  Options ExecCGI\n";
	print FF "  allow from all\n";
	print FF "  PerlSendHeader On\n";
	print FF "</Location>\n\n";
}

close(FH);
close(FF);
