<?xml version="1.0"?>
<!DOCTYPE methoddef SYSTEM "rpc-method.dtd">
<!--
    Generated automatically by make_method v1.09, Sat Sep  4 08:46:54 2004

    Any changes made here will be lost.
-->
<methoddef>
<name>cards</name>
<version>1.0</version>
<signature>array int</signature>
<help>
Lists files or directories.
</help>
<code language="perl">
<![CDATA[
#!/opt/perl5/bin/perl
###############################################################################
#
#   Sub Name:       cards
#
#   Description:    Returns card information, alarms, etc
#
#   Arguments:      NAME      IN/OUT  TYPE      DESCRIPTION
#                   $srv      in      ref       Server object instance
#                   $card     in      string    Card number [optional]
#
#   Globals:        None.
#
#   Environment:    None.
#
#   Returns:        Array of cards and info
#
###############################################################################
sub cards
{
open(LOG, ">>/tmp/xpl.log"); print LOG localtime() . ": $$: cards.xpl(@_)\n"; close(LOG);
        my ($srv, $card) = @_;

	use strict;

	my %alarms = (
        none            => 0,
        recover         => 1,
        loopback        => 2,
        yellow          => 4,
        red             => 8,
        blue            => 16,
        notopen         => 32,
	);

	my $ZT_SPANSTAT = -1066382838;

	my $zap = -e "/dev/dahdi" ? "dahdi" : "zap";
	open(CTL, "+</dev/$zap/ctl") || return "Couldn't open /dev/$zap/ctl for rw: $!";

	my @cards;
	my @spans = $card ? ($card) : (1 .. 12);
	foreach my $span (@spans)
	{
	        my $spaninfo = zt_spaninfo({ spanno => $span });
	        ioctl(CTL, $ZT_SPANSTAT, $spaninfo) || last;
	        $cards[$span-1] = { zt_spaninfo_unp($spaninfo) };

	        $cards[$span-1]{alarms_text} = [ grep { $cards[$span-1]{alarms} & $alarms{$_} } keys %alarms ];
	}
	close(CTL);

	sub zt_spaninfo
	{
        my %tmp = %{$_[0]};

        return
        pack("iA20A40iiiiiiiiiiii",
                $tmp{spanno},
                $tmp{name},
                $tmp{desc},
                $tmp{alarms},
                $tmp{txlevel},
                $tmp{rxlevel},
                $tmp{bpvcount},
                $tmp{crc4count},
                $tmp{ebitcount},
                $tmp{fascount},
                $tmp{irqmisses},
                $tmp{syncsrc},
                $tmp{numchans},
                $tmp{totalchans},
                $tmp{totalspans},
        );
	}

	sub zt_spaninfo_unp
	{
        my $tmp = shift;
        my @tmp = unpack("iA20A40iiiiiiiiiiii", $tmp);

        my $i = 0;
        return map { $_ => $tmp[$i++] }
                qw/spanno name desc alarms txlevel rxlevel bpvcount crc4count
                ebitcount fascount irqmisses syncsrc numchans totalchans totalspans/;
	}

	return \@cards;
}

__END__
]]></code>
</methoddef>
