#!/usr/bin/perl
#
# Executes remote tcpdump as root.
#

use strict;
use warnings;

# Usage: sutcpdump <action> <server id> <port to watch> <originating hostname>
#
# Ex Start: sutcpdump start 1358 5060 web11.fonality.com
# Ex Stop:  sutcpdump stop 1358 5060 web11.fonality.com
my $usage = "$0 <start|stop> <server_id> <port> <hostname>";

my ($action,$sid,$port,$host) = @ARGV;

if ($action !~ /^(start|stop)$/i)
{
	die "Usage: $usage\nAction must be start or stop";
}
elsif ($action eq 'start')
{
	# If action=start, the other fields are required.
	if ($sid !~ /^\d+$/ || $port !~ /^\d+$/)
	{
		die "Usage: $usage\nSID and Port must be numeric";
	}
	if (!defined $host)
	{
		die "Usage: $usage\nInvalid hostname";
	}
}

# if we're allowed to run this program
if ($action eq 'start')
{
	my $cmd = "ssh pbxtra$sid 'tcpdump -l port $port and host $host 2>>/dev/null'";
	my $results = `$cmd`;
	print $results;
}
else {
	my $cmd = "ssh pbxtra$sid 'killall -9 tcpdump 2>>/dev/null'";
	system ($cmd);
}

exit(0);
